#### challenge2.py

from tkinter import *

# Variables and button label text:
text_box_width = 75
text_box_height = 2
current_key = 1
b1 = "ENCODE"
b2 = "DECODE"
b3 = "CLEAR"

# Functions
def set_key(value):
    global current_key
    current_key = value

def clear_text():
    entry.delete(1.0, END) # 1.0 = index for the first line and first character
    output.delete(1.0, END)

def make_code():
    key = current_key
    encode_decode(key, "encode")

def decode():
    key = -current_key
    encode_decode(key, "decode")

def encode_decode(key, e_d):
    alphabet = "abcdefghijklmnopqrstuvwxyz"
    text_in = entry.get(1.0, END)
    text_in = text_in.lower()
    text_out = ""
    
    for letter in text_in:
        if letter in alphabet:
            i = alphabet.find(letter)
            j = i + key
            text_out = text_out + alphabet[j % 26]
        else:
            text_out = text_out + letter
    output.delete(1.0, END)
    
    if e_d == "encode":
        text_out = text_out.upper()
        
    output.insert(END, text_out)

##### Main:
window = Tk()
window.title("The Caesar Machine")

# Add buttons:
buttons = Frame(window)
buttons.grid(row=2, column=1, sticky=S)

Button(buttons, text=b1, width=10, command=make_code).grid(row=0, column=0)
Button(buttons, text=b2, width=10, command=decode).grid(row=0, column=1)
Button(buttons, text=b3, width=10, command=clear_text).grid(row=0, column=2)

# Create a label
Label(window, text="Input:").grid(row=0, column=0, sticky=W)

# Create text entry box
entry = Text(window, width=text_box_width, height=text_box_height, wrap=WORD, background="light green")
entry.grid(row=0, column=1, sticky=W)

# Create another label
Label(window, text="Output:").grid(row=1, column=0, sticky=W)

# Create text output box
output = Text(window, width=text_box_width, height=text_box_height, wrap=WORD, background="light green")
output.grid(row=1, column=1, sticky=W)

# Add label
Label(window, text="Cipher Key:").grid(row=0, column=2, sticky=W)

# Create the cipher key dropdown:
options = tuple(range(1,27))
var = IntVar()
var.set("1") # initial value
dropdown = OptionMenu(window, var, *options, command=set_key)
dropdown.grid(row=0, column=3, sticky=E)

##### Run mainloop
window.mainloop()
