# challenge4.py
# This game has three scenes in a 4x4 map
# The aim is to collect the phone and sim card and find a signal.

# Set global variables
backpack = []
act = 0
current_location = [0,1]

# Build the empty map
scenes = (
    ({},{},{},{}),
    ({},{},{},{}),
    ({},{},{},{}),
    ({},{},{},{})
    )

# Load the map with scenes
scenes[0][1]["name"] = "The Car"
scenes[0][1]["item"] = "mobile phone"

scenes[1][1]["name"] = "Yard"

scenes[1][2]["name"] = "Office"
scenes[1][2]["item"] = "sim card"

# Create stories for each scene:
acts = (
    {
        "The Car": "You have left your phone somewhere but cannot find it.\nHow annoying :-(",
        "Yard": "It's a nice day. Now where is that phone?",
        "Office": "This is where Mum works.\nWe call it Mum's Office but she refers to it as 'My Sanctuary'."
    },
    {
        "The Car": "Your phone does not appear to work here.",
        "Yard": "Would I really have left my phone outside??",
        "Office": "Your phone does not appear to work here."
    },
    {
        "The Car": "Grr! My mobile gets no reception here either!",
        "Yard": "Finally, you have a working phone and a decent signal!\nRing ring...\nRing ring...\n\nPress 'Quit' to finish.",
        "Office": "You have a phone with a sim card but still cannot use it as there is no reception."
    }
)

# Functions
def tell_story():
    update_act()
    scene_name = get_scene()["name"]
    print("\nYou are in the " + scene_name + "\n")
    print(acts[act][scene_name])

def update_act():
    global act
    if("mobile phone" in backpack) and ("sim card" in backpack):
        act = 2
    elif "mobile phone" in backpack:
        act = 1
    return act

def get_scene():
    return scenes[current_location[0]][current_location[1]]

def look():
    if "item" in get_scene():
        print("You can see a " + get_scene()["item"])
    else:
        print("Nothing to see here.")

def grab():
    if "item" in get_scene():
        backpack.append(get_scene()["item"])
        print("You now have the " + get_scene()["item"])
        del get_scene()["item"]
    else:
        print("Nothing to grab here.")

def inventory():
    if len(backpack) != 0:
        print(backpack)
    else:
        print("You have not collected anything yet.")

def move_north():
    current_location[0] = current_location[0]-1
    if is_off_map() or is_no_scene():
        current_location[0] = current_location[0]+1
        print("You have bumped into a wall.")

def move_south():
    current_location[0] = current_location[0]+1
    if is_off_map() or is_no_scene():
        current_location[0] = current_location[0]-1
        print("You have bumped into a wall.")

def move_east():
    current_location[1] = current_location[1]+1
    if is_off_map() or is_no_scene():
        current_location[1] = current_location[1]-1
        print("You have bumped into a wall.")

def move_west():
    current_location[1] = current_location[1]-1
    if is_off_map() or is_no_scene():
        current_location[1] = current_location[1]+1
        print("You have bumped into a wall.")

def is_no_scene():
    if get_scene():
        return False
    else:
        return True

def is_off_map():
    x = current_location[1]
    y = current_location[0]
    if (x < 0) or (x > 2) or (y < 0) or (y > 2):
        return True
    else:
        return False

#### Start the game
name=input("Hi, welcome to my world.\nWhat is your name? ")
print("Have fun exploring my world", name, "\nHere are the commands you can use:")
print("L = look\nG = grab\nI = inventory\nN = go north\nS = go south\nW = go west\nE = go east\nQ = quit.")

# Create an infinite loop
while True:
    command=input("What do you want to do? ")
    if (command == "L" or command == "l"):
        look()
    elif (command == "G" or command == "g"):
        grab()
    elif (command == "I" or command == "i"):
        inventory()
    elif (command == "N" or command == "n"):
        move_north()
        tell_story()
    elif (command == "S" or command == "s"):
        move_south()
        tell_story()
    elif (command == "E" or command == "e"):
        move_east()
        tell_story()
    elif (command == "W" or command == "w"):
        move_west()
        tell_story()
    elif (command == "Q" or command == "q"):
        break
    else:
        print("\nPlease enter only L, G, I, N, S, E, W or Q ")

print("\nThanks for playing", name)
